      PROGRAM fitdiv
      REAL*8 rstrain(100),ecLattice(100),vol0,res,yp(100)
      REAL*8 emin,emax,pas,eo,val,eps,eps2,res2,cof
      INTEGER n,ndeg,ierr,i,st
      CHARACTER*4 str
      CHARACTER*8 str1
      CHARACTER*13 str2
      CHARACTER*14 str4
      CHARACTER*14 str3

      CHARACTER*79 row
      CHARACTER*23 expers
      CHARACTER*4  latt
      INTEGER noatom,spgnum,spgmode
      REAL*8,allocatable :: x(:),y(:),w(:),r(:),a(:)
     
      OPEN(unit=10,file='number.strain',status='old',err=7000)
      READ(10,*) n 
      CLOSE(10)
      OPEN(unit=20,file='vol.optimize',status='old',err=6000)
      READ(20,*) vol0 
      CLOSE(20)
      OPEN(unit=50,file='.styp',status='old',err=9000)
      READ(50,*) st 
      CLOSE(50)
!********** read information from .spgnum file ****
      OPEN(unit=15,file='.spgnum',status='old',err=3000)
      READ(15,*) spgnum
      close(15) 
!******************************************************
!       Oblique system
!       2D space group: p1, p2
!       (6 independent elastic constants)      

        if (spgnum .GE. 3 .AND. spgnum .LE. 15) then
                spgmode=1
      SELECT CASE (st)
       CASE(1) 
       cof=1
       str=' C11'
       CASE(2) 
       cof=1
       str=' C22'
       CASE(4) 
       cof=1
       str2=' C11+C22+2C12'
       CASE(3) 
       cof=4
       str=' C66'
       CASE(6) 
       cof=1
       str3=' C22+4C66+4C26'
       CASE(5) 
       cof=1
       str4=' C11+4C66+4C16'
      END SELECT 

        endif
!******************************************************
!       Rectanglar system
!       2D space group: pm, pg, p2mm, p2gg, p2mg, cm, c2mm      
!       (4 independent elastic constants)  

        if (spgnum .GE. 16 .AND. spgnum .LE. 74) then
                spgmode=2
      SELECT CASE (st)
       CASE(1) 
       cof=1
       str=' C11'
       CASE(2) 
       cof=1
       str=' C22'
       CASE(4) 
       cof=1
       str2=' C11+C22+2C12'
       CASE(3) 
       cof=4
       str=' C66'
      END SELECT 

        endif
!******************************************************
!       Square system
!       2D space group: p4, p4mm, p4gm
!       (3 independent elastic constants)

        if (spgnum .GE. 75 .AND. spgnum .LE. 142) then
                spgmode=3
      SELECT CASE (st)
       CASE(1) 
       cof=1
       str=' C11'
       CASE(4) 
       cof=2
       str1=' C11+C12'
       CASE(3) 
       cof=4
       str=' C66'
      END SELECT 

        endif
!******************************************************
!       Hexagonl system
!       2D space group: p3, p6, p3m1, p31m, p6mm
!       (2 independent elastic constants)  

        if (spgnum .GE. 143 .AND. spgnum .LE. 194) then
                spgmode=4
      SELECT CASE (st)
       CASE(4) 
       cof=2
       str1=' C11+C12'
       CASE(3) 
       cof=4
       str=' C66'
      END SELECT 

        endif

!******************************************************       
      OPEN(unit=40,file='VstVene',status='old',err=8000)
      allocate( x(n),y(n),w(n),r(n),a(6*n+3))
     
      DO i=1,n
         READ(40,*) rstrain(i),ecLattice(i)
         WRITE(*,800) rstrain(i),ecLattice(i)
      ENDDO
      CLOSE(40)
      WRITE(*,*) '==============================================================='   
      DO i=1,n
         x(i)=rstrain(i)
         y(i)=ecLattice(i)
         w(i)=-1.d0
      ENDDO

      OPEN(unit=25,file='ELCorder.fit') 
#---read pressure from .pressure file if there is otherwise pressure is zero-----

      OPEN(unit=70,file='.pressure',status='old',err=4000)
      READ(70,*) Pre 
      CLOSE(70) 
      GOTO 4010 
 4000 Pre=0
 4010 WRITE(*,950) Pre
      WRITE(*,*) '==============================================================='   
#--------convert pressure from GPa to a.u.  unit----------------
      Pre=Pre/14710.5164057d0
#--------------------------------------------------------------

#----------------------------------------------------------------------

      DO j=3,n  
      eps=1.d-16
      CALL dpolft(n,x,y,w,j-1,ndeg,eps,r,ierr,a)
      CALL dp1vlu(ndeg,2,0.d0,val,yp,a)
#---when we suppose pressure is zero ELC is res=d2/dx2(E(V,strain))/V/cof---
      res=yp(2)/vol0/cof
#------when pressure there is ELC (here res) changes--ELC=d2/dx2(E(V,strain))/V/cof+X*P
!      SELECT CASE (st)
!       CASE(1) 
!       res=res+Pre
!       CASE(2) 
!       res=res+2*Pre
!       CASE(3) 
!       res=res+Pre
!       CASE(4) 
!       res=res+0.5d0*Pre
!       CASE(5) 
!       res=res+6*Pre
!      END SELECT        

#--------------------------------------------------------------------------

#*****************define res2=d2/dx2(e0+a*x+ELC*x^2)********************
      if ( j==4) then
       res2=res
       eps2=eps
      endif 
#***********************************************************************
# ****** convert unit of elastic constants from Ryd/bohr^2 to N/m ******
# 1Ryd=2.179874099*10^(-19) J , 1bohr=5.2918*10^(-11) m , 1J=1N*m
# 1 Ryd/bohr^2 = 778.438966 N/m
#***********************************************************************
      write(25,700) j-1,res*778.438966d0,eps
      if ( (st==1 .or. st==2 .or. st==3) .and. (spgmode==1 .or. spgmode==2 .or. spgmode==3 .or. spgmode==4) ) then
      write(*,600) j-1,str,res*778.438966d0,eps
      endif
      if ( (st==4) .and. (spgmode==1 .or. spgmode==2) ) then
      write(*,607) j-1,str2,res*778.438966d0,eps
      endif
      if ( (st==4) .and. (spgmode==3 .or. spgmode==4)) then
      write(*,605) j-1,str1,res*778.438966d0,eps
      endif


      if (st==5 .and. spgmode==1) then
      write(*,609) j-1,str4,res*778.438966d0,eps
      endif

      if (st==6 .and. spgmode==1 ) then
      write(*,608) j-1,str3,res*778.438966d0,eps
      endif

      ENDDO

      CLOSE(25)
#********************************************************
      emin=rstrain(1)
      emax=emin
      DO i=1,n
         IF (rstrain(i).ge.emax) emax=rstrain(i)
         IF (rstrain(i).le.emin) emin=rstrain(i)
      ENDDO      
#      WRITE(*,*) emax,emin
      OPEN(unit=20,file='ELC.fit') 
      OPEN(unit=30,file='ELCdiv2.fit') 
      pas=(emax-emin)/100.d0
      DO i=1,101
         eo=emin+(i-1)*pas
         CALL dp1vlu(ndeg,0,eo,val,yp,a)
         write(20,800) eo,val
         CALL dp1vlu(ndeg,2,eo,val,yp,a)
         write(30,800) eo,yp(2)/vol0*778.438966d0/cof
      ENDDO
      CLOSE(20)
      CLOSE(30)


      
#      OPEN(unit=40,file='VstVene')
#      DO i=1,n
#         WRITE(40,800) rstrain(i),ecLattice(i)
#      ENDDO
#      CLOSE(40)


      OPEN(unit=30,file='ELC.output')
      if ( (st==1 .or. st==2 .or. st==3) .and. (spgmode==1 .or. spgmode==2 .or. spgmode==3 .or. spgmode==4) ) then
      WRITE(30,*) 'Polynomial fit for',str,' done'
      WRITE(*,*) '******************************************'
      WRITE(*,*) 'Polynomial fit for',str,' done'
      endif

      if ( (st==4) .and. (spgmode==1 .or. spgmode==2) ) then
      WRITE(30,*) 'Polynomial fit for',str2,' done'
      WRITE(*,*) '******************************************'
      WRITE(*,*) 'Polynomial fit for',str2,' done'
      endif

      if ( (st==4) .and. (spgmode==3 .or. spgmode==4)) then
      WRITE(30,*) 'Polynomial fit for',str1,' done'
      WRITE(*,*) '******************************************'
      WRITE(*,*) 'Polynomial fit for',str1,' done'
      endif


      if (st==5 .and. spgmode==1) then
      WRITE(30,*) 'Polynomial fit for',str4,' done'
      WRITE(*,*) '******************************************'
      WRITE(*,*) 'Polynomial fit for',str4,' done'
      endif


      if (st==6 .and. spgmode==1 ) then
      WRITE(30,*) 'Polynomial fit for',str3,' done'
      WRITE(*,*) '******************************************'
      WRITE(*,*) 'Polynomial fit for',str3,' done'
      endif


      WRITE(30,910) eps2,2
      WRITE(*,910) eps2,2
      WRITE(30,900) vol0
      WRITE(*,900) vol0
      if ( (st==1 .or. st==2 .or. st==3) .and. (spgmode==1 .or. spgmode==2 .or. spgmode==3 .or. spgmode==4) ) then
      WRITE(30,920) str,res2,res2*778.438966d0
      WRITE(*,920) str,res2,res2*778.438966d0
      endif
      if ( (st==4) .and. (spgmode==1 .or. spgmode==2) ) then
      WRITE(30,927) str2,res2,res2*778.438966d0
      WRITE(*,927) str2,res2,res2*778.438966d0
      endif

      if ( (st==4) .and. (spgmode==3 .or. spgmode==4)) then
      WRITE(30,926) str1,res2,res2*778.438966d0
      WRITE(*,926) str1,res2,res2*778.438966d0
      endif


      if (st==5 .and. spgmode==1) then
      WRITE(30,929) str4,res2,res2*778.438966d0
      WRITE(*,929) str4,res2,res2*778.438966d0
      endif


      if (st==6 .and. spgmode==1) then
      WRITE(30,928) str3,res2,res2*778.438966d0
      WRITE(*,928) str3,res2,res2*778.438966d0
      endif

      WRITE(*,*) '******************************************'
      WRITE(*,*) ' '
      WRITE(30,*) ' '
      WRITE(30,930)
      DO i=1,n
         WRITE(30,940) rstrain(i),ecLattice(i),r(i)-ecLattice(i)
      ENDDO

      CLOSE(30)

      
      deallocate( x,y,w,r,a)
 600  FORMAT('Order of fit: ',I2,a4,' is: ',F11.4,' N/m, RMS: ',E12.6) 
 605  FORMAT('Order of fit: ',I2,a8,' is: ',F11.4,' N/m, RMS: ',E12.6) 

 607  FORMAT('Order of fit: ',I2,a13,' is: ',F11.4,' N/m, RMS: ',E12.6) 
 608  FORMAT('Order of fit: ',I2,a14,' is: ',F11.4,' N/m, RMS: ',E12.6) 
 609  FORMAT('Order of fit: ',I2,a14,' is: ',F11.4,' N/m, RMS: ',E12.6) 

 700  FORMAT(I2,2X,F9.3,2X,E12.6)
 800  FORMAT(F9.6,1X,F15.6)
 900  FORMAT(/,'At surface= ',F9.4,' bohr^2')
 910  FORMAT('A RMS of ',E12.6,' was achieved using a polynome of degree : ',I2)
 920  FORMAT(a4,' is: ',F10.6,' Ryd/bohr^2 or ',F11.4,' N/m')
 927  FORMAT(a13,' is: ',F10.6,' Ryd/bohr^2 or ',F11.4,' N/m')
 926  FORMAT(a8,' is: ',F10.6,' Ryd/bohr^2 or ',F11.4,' N/m')

 928  FORMAT(a14,' is: ',F10.6,' Ryd/bohr^2 or ',F11.4,' N/m')
 929  FORMAT(a14,' is: ',F10.6,' Ryd/bohr^2 or ',F11.4,' N/m')

 930  FORMAT(9x,'Strain',7x,'energy',10x,'dE')
 940  FORMAT(F14.8,F14.6,E14.6)
 950  FORMAT(' Pressure is: ',F9.4,' GPa')



      GOTO 8001

 3000 WRITE(*,*) 'No valid .spgnum file'
      STOP

 6000 write(*,*) 'Error. There is not vol.optimize file'

      STOP


 7000 write(*,*) 'Error. There is not number.strain file'

      STOP

 8000 write(*,*) 'Error. There is not VstVene file'

      STOP
 9000 write(*,*) 'Error. There is not .styp file'

      STOP

 8001 write(*,*) 'Analyze done.....'

     END
